/*! \file Vertex.h 
 *  \brief: header file for vertex object
 */

#ifndef _VERTEX_H_
#define _VERTEX_H_

#include "./Object.h"

class Vertex: public Object{

	public: 

		int  id;
		double x;
		double y;
		double z;
		double sigma; //sigma coordinate: (z-bed)/thickness

		/*dof management: */
		int    partitionborder;
		int    clone;
		int    dof; //dof to recover values in a vertex indexed vector

		/*FUNCTION constructors, destructors {{{1*/
		Vertex();
		Vertex(int id, double x, double y, double z, double sigma,int partitionborder); 
		Init(int id, double x, double y, double z, double sigma,int partitionborder);
		Vertex(int i, IoModel* iomodel);
		~Vertex();
		/*}}}*/
		/*FUNCTION object management {{{1*/
		Object* copy();
		void  DeepEcho();
		void  Demarshall(char** pmarshalled_dataset);
		void  Echo();
		int   Enum();
		int   GetId(void); 
		char* GetName();
		void  Marshall(char** pmarshalled_dataset);
		int   MarshallSize();
		int   MyRank();
		void  UpdateFromDakota(void* vinputs);
		void  UpdateFromInputs(void* vinputs);
		void  UpdatePosition(double* thickness,double* bed);


		/*}}}*/

};
#endif  /* _VERTEX_H */
